=== lib/irrlicht/CMakeLists.txt ===
# CMakeLists.txt for Irrlicht in STK

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include/
                    ${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/jpeglib
                    ${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/libpng
                    ${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/zlib
                    ${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/bzip2)

if(APPLE)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht/MacOSX ${CMAKE_CURRENT_SOURCE_DIR}/source/Irrlicht)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -arch i386")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -arch i386 -F/Library/Frameworks")
endif()

add_definitions(-DNDEBUG=1 -DIRRLICHT_EXPORTS=1 -DPNG_THREAD_UNSAFE_OK -DPNG_NO_MMX_CODE -DPNG_NO_MNG_FEATURES)
if(MSVC)
  add_definitions(/D_IRR_STATIC_LIB_)
  add_definitions(/D_CRT_SECURE_NO_WARNINGS) # Shut up about unsafe stuff
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wall -pipe -O3  -fno-exceptions -fno-rtti -fstrict-aliasing -fexpensive-optimizations -I/usr/X11R6/include")
  set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -Wall -pipe -O3  -fno-exceptions -fno-rtti -fstrict-aliasing -fexpensive-optimizations -I/usr/X11R6/include")
endif()

set(IRRLICHT_SOURCES
source/Irrlicht/CTRStencilShadow.cpp
source/Irrlicht/CGUIListBox.cpp
source/Irrlicht/CZBuffer.cpp
source/Irrlicht/CGUIModalScreen.cpp
source/Irrlicht/CParticleCylinderEmitter.cpp
source/Irrlicht/CLimitReadFile.cpp
source/Irrlicht/CVideoModeList.cpp
source/Irrlicht/CDefaultGUIElementFactory.cpp
source/Irrlicht/CCubeSceneNode.cpp
source/Irrlicht/CGUIMeshViewer.cpp
source/Irrlicht/CBSPMeshFileLoader.cpp
source/Irrlicht/CParticleSphereEmitter.cpp
source/Irrlicht/CTRFlatWire.cpp
source/Irrlicht/CParticleAnimatedMeshSceneNodeEmitter.cpp
source/Irrlicht/CGUITabControl.cpp
source/Irrlicht/IBurningShader.cpp
source/Irrlicht/CSoftwareTexture.cpp
source/Irrlicht/CTRFlat.cpp
source/Irrlicht/CD3D9NormalMapRenderer.cpp
source/Irrlicht/CGUIToolBar.cpp
source/Irrlicht/CTerrainTriangleSelector.cpp
source/Irrlicht/CFileSystem.cpp
source/Irrlicht/CTerrainSceneNode.cpp
source/Irrlicht/CTRTextureFlat.cpp
source/Irrlicht/os.cpp
source/Irrlicht/CFPSCounter.cpp
source/Irrlicht/CGUIContextMenu.cpp
source/Irrlicht/CImageWriterJPG.cpp
source/Irrlicht/CAnimatedMeshMD2.cpp
source/Irrlicht/CTRTextureGouraudNoZ2.cpp
source/Irrlicht/CZipReader.cpp
source/Irrlicht/CTRTextureLightMap2_M4.cpp
source/Irrlicht/CImageLoaderPNG.cpp
source/Irrlicht/CImageLoaderBMP.cpp
source/Irrlicht/CIrrDeviceWinCE.cpp
source/Irrlicht/CVolumeLightSceneNode.cpp
source/Irrlicht/CDefaultSceneNodeAnimatorFactory.cpp
source/Irrlicht/CSkyDomeSceneNode.cpp
source/Irrlicht/CGUIFileOpenDialog.cpp
source/Irrlicht/CTRGouraudAlphaNoZ2.cpp
source/Irrlicht/CGUISpriteBank.cpp
source/Irrlicht/CParticleFadeOutAffector.cpp
source/Irrlicht/CGUIMenu.cpp
source/Irrlicht/CCgMaterialRenderer.cpp
source/Irrlicht/CMD2MeshFileLoader.cpp
source/Irrlicht/CImageWriterPSD.cpp
source/Irrlicht/CD3D9ParallaxMapRenderer.cpp
source/Irrlicht/CLWOMeshFileLoader.cpp
source/Irrlicht/CSphereSceneNode.cpp
source/Irrlicht/CLMTSMeshFileLoader.cpp
source/Irrlicht/CImageWriterTGA.cpp
source/Irrlicht/CImageWriterPNG.cpp
source/Irrlicht/CSceneNodeAnimatorFollowSpline.cpp
source/Irrlicht/CGUIMessageBox.cpp
source/Irrlicht/CParticleGravityAffector.cpp
source/Irrlicht/CGUISkin.cpp
source/Irrlicht/CBoneSceneNode.cpp
source/Irrlicht/CSoftwareTexture2.cpp
source/Irrlicht/CD3D8ParallaxMapRenderer.cpp
source/Irrlicht/CTRTextureLightMap2_M1.cpp
source/Irrlicht/CNPKReader.cpp
source/Irrlicht/CIrrMeshFileLoader.cpp
source/Irrlicht/COpenGLSLMaterialRenderer.cpp
source/Irrlicht/CParticleRotationAffector.cpp
source/Irrlicht/CAnimatedMeshHalfLife.cpp
source/Irrlicht/CD3D9HLSLMaterialRenderer.cpp
source/Irrlicht/CDepthBuffer.cpp
source/Irrlicht/CImageLoaderPSD.cpp
source/Irrlicht/CTRNormalMap.cpp
source/Irrlicht/CTriangleBBSelector.cpp
source/Irrlicht/CAnimatedMeshMD3.cpp
source/Irrlicht/CGUIComboBox.cpp
source/Irrlicht/CSceneNodeAnimatorTexture.cpp
source/Irrlicht/CColladaMeshWriter.cpp
source/Irrlicht/COpenGLTexture.cpp
source/Irrlicht/COgreMeshFileLoader.cpp
source/Irrlicht/COctreeSceneNode.cpp
source/Irrlicht/CWaterSurfaceSceneNode.cpp
source/Irrlicht/CQuake3ShaderSceneNode.cpp
source/Irrlicht/CWADReader.cpp
source/Irrlicht/CParticleAttractionAffector.cpp
source/Irrlicht/CMeshSceneNode.cpp
source/Irrlicht/CCSMLoader.cpp
source/Irrlicht/COBJMeshWriter.cpp
source/Irrlicht/CGUIScrollBar.cpp
source/Irrlicht/CAttributes.cpp
source/Irrlicht/CTRTextureGouraudAdd.cpp
source/Irrlicht/CGUIStaticText.cpp
source/Irrlicht/CSceneNodeAnimatorCollisionResponse.cpp
source/Irrlicht/CGUIFont.cpp
source/Irrlicht/CBurningShader_Raster_Reference.cpp
source/Irrlicht/CD3D8ShaderMaterialRenderer.cpp
source/Irrlicht/CTriangleSelector.cpp
source/Irrlicht/CTRTextureDetailMap2.cpp
source/Irrlicht/CParticlePointEmitter.cpp
source/Irrlicht/CD3D9Driver.cpp
source/Irrlicht/CTRTextureGouraudAlphaNoZ.cpp
source/Irrlicht/CTextSceneNode.cpp
source/Irrlicht/CD3D9CgMaterialRenderer.cpp
source/Irrlicht/COpenGLCgMaterialRenderer.cpp
source/Irrlicht/CIrrDeviceLinux.cpp
source/Irrlicht/CD3D9ShaderMaterialRenderer.cpp
source/Irrlicht/CIrrDeviceStub.cpp
source/Irrlicht/CQ3LevelMesh.cpp
source/Irrlicht/CTRTextureLightMap2_M2.cpp
source/Irrlicht/CDMFLoader.cpp
source/Irrlicht/CImageWriterPCX.cpp
source/Irrlicht/CGUIInOutFader.cpp
source/Irrlicht/CGUITreeView.cpp
source/Irrlicht/CAnimatedMeshSceneNode.cpp
source/Irrlicht/CGUICheckBox.cpp
source/Irrlicht/CGUIWindow.cpp
source/Irrlicht/CTRTextureWire2.cpp
source/Irrlicht/CPLYMeshFileLoader.cpp
source/Irrlicht/CSceneNodeAnimatorCameraMaya.cpp
source/Irrlicht/CSceneNodeAnimatorFlyCircle.cpp
source/Irrlicht/CColorConverter.cpp
source/Irrlicht/CMeshCache.cpp
source/Irrlicht/CTRTextureGouraudWire.cpp
source/Irrlicht/CIrrDeviceFB.cpp
source/Irrlicht/CMemoryFile.cpp
source/Irrlicht/CImageWriterPPM.cpp
source/Irrlicht/CSTLMeshFileLoader.cpp
source/Irrlicht/CMountPointReader.cpp
source/Irrlicht/CBillboardSceneNode.cpp
source/Irrlicht/CMS3DMeshFileLoader.cpp
source/Irrlicht/CGUIImageList.cpp
source/Irrlicht/CTRGouraud.cpp
source/Irrlicht/CTRTextureGouraudAlpha.cpp
source/Irrlicht/CSceneCollisionManager.cpp
source/Irrlicht/CIrrDeviceWin32.cpp
source/Irrlicht/CSceneLoaderIrr.cpp
source/Irrlicht/CEmptySceneNode.cpp
source/Irrlicht/CParticleBoxEmitter.cpp
source/Irrlicht/CParticleSystemSceneNode.cpp
source/Irrlicht/CIrrDeviceConsole.cpp
source/Irrlicht/CPakReader.cpp
source/Irrlicht/CImage.cpp
source/Irrlicht/CTarReader.cpp
source/Irrlicht/CGUIButton.cpp
source/Irrlicht/COpenGLParallaxMapRenderer.cpp
source/Irrlicht/CGUIEditBox.cpp
source/Irrlicht/CLogger.cpp
source/Irrlicht/CMeshManipulator.cpp
source/Irrlicht/CLightSceneNode.cpp
source/Irrlicht/CTRTextureLightMapGouraud2_M4.cpp
source/Irrlicht/CImageLoaderDDS.cpp
source/Irrlicht/CSkyBoxSceneNode.cpp
source/Irrlicht/CWriteFile.cpp
source/Irrlicht/CSTLMeshWriter.cpp
source/Irrlicht/COctreeTriangleSelector.cpp
source/Irrlicht/CSMFMeshFileLoader.cpp
source/Irrlicht/CFileList.cpp
source/Irrlicht/CXMeshFileLoader.cpp
source/Irrlicht/CImageLoaderPCX.cpp
source/Irrlicht/CIrrDeviceSDL.cpp
source/Irrlicht/CTRTextureGouraudNoZ.cpp
source/Irrlicht/COSOperator.cpp
source/Irrlicht/CImageLoaderJPG.cpp
source/Irrlicht/CTRGouraudWire.cpp
source/Irrlicht/CMD3MeshFileLoader.cpp
source/Irrlicht/CIrrMeshWriter.cpp
source/Irrlicht/COpenGLExtensionHandler.cpp
source/Irrlicht/CImageLoaderWAL.cpp
source/Irrlicht/CXMLWriter.cpp
source/Irrlicht/COCTLoader.cpp
source/Irrlicht/COBJMeshFileLoader.cpp
source/Irrlicht/CSceneNodeAnimatorCameraFPS.cpp
source/Irrlicht/CD3D8Texture.cpp
source/Irrlicht/CImageLoaderPPM.cpp
source/Irrlicht/CTRTextureLightMap2_Add.cpp
source/Irrlicht/CMY3DMeshFileLoader.cpp
source/Irrlicht/CTRGouraud2.cpp
source/Irrlicht/CGUIColorSelectDialog.cpp
source/Irrlicht/CSceneManager.cpp
source/Irrlicht/Irrlicht.cpp
source/Irrlicht/COpenGLShaderMaterialRenderer.cpp
source/Irrlicht/CImageLoaderTGA.cpp
source/Irrlicht/CTRTextureGouraud2.cpp
source/Irrlicht/COpenGLDriver.cpp
source/Irrlicht/CSceneNodeAnimatorFlyStraight.cpp
source/Irrlicht/irrXML.cpp
source/Irrlicht/CImageLoaderRGB.cpp
source/Irrlicht/CSoftwareDriver2.cpp
source/Irrlicht/CSoftwareDriver.cpp
source/Irrlicht/CD3D8Driver.cpp
source/Irrlicht/CD3D9Texture.cpp
source/Irrlicht/CTRTextureBlend.cpp
source/Irrlicht/CSkinnedMesh.cpp
source/Irrlicht/CTRGouraudAlpha2.cpp
source/Irrlicht/CXMLReader.cpp
source/Irrlicht/CDummyTransformationSceneNode.cpp
source/Irrlicht/CTRTextureGouraudVertexAlpha2.cpp
source/Irrlicht/C3DSMeshFileLoader.cpp
source/Irrlicht/CD3D8NormalMapRenderer.cpp
source/Irrlicht/CGUITable.cpp
source/Irrlicht/CB3DMeshFileLoader.cpp
source/Irrlicht/CGeometryCreator.cpp
source/Irrlicht/CNullDriver.cpp
source/Irrlicht/CCameraSceneNode.cpp
source/Irrlicht/CTRTextureGouraudAdd2.cpp
source/Irrlicht/CGUISpinBox.cpp
source/Irrlicht/CTRTextureGouraudAddNoZ2.cpp
source/Irrlicht/CReadFile.cpp
source/Irrlicht/CColladaFileLoader.cpp
source/Irrlicht/CParticleRingEmitter.cpp
source/Irrlicht/CMetaTriangleSelector.cpp
source/Irrlicht/CShadowVolumeSceneNode.cpp
source/Irrlicht/CDefaultSceneNodeFactory.cpp
source/Irrlicht/CGUIImage.cpp
source/Irrlicht/CGUIEnvironment.cpp
source/Irrlicht/CParticleScaleAffector.cpp
source/Irrlicht/CSceneNodeAnimatorDelete.cpp
source/Irrlicht/CPLYMeshWriter.cpp
source/Irrlicht/CImageWriterBMP.cpp
source/Irrlicht/CTRTextureGouraud.cpp
source/Irrlicht/CParticleMeshEmitter.cpp
source/Irrlicht/CSceneNodeAnimatorRotation.cpp
source/Irrlicht/COpenGLNormalMapRenderer.cpp
source/Irrlicht/CTRTextureFlatWire.cpp
source/Irrlicht/glext.h
source/Irrlicht/CB3DMeshFileLoader.h
source/Irrlicht/CIrrDeviceLinux.h
source/Irrlicht/CMeshCache.h
source/Irrlicht/CAttributes.h
source/Irrlicht/CMS3DMeshFileLoader.h
source/Irrlicht/CParticleMeshEmitter.h
source/Irrlicht/CImageWriterPPM.h
source/Irrlicht/CParticlePointEmitter.h
source/Irrlicht/CParticleRotationAffector.h
source/Irrlicht/CMountPointReader.h
source/Irrlicht/CIrrDeviceConsole.h
source/Irrlicht/CTerrainSceneNode.h
source/Irrlicht/CSceneNodeAnimatorCollisionResponse.h
source/Irrlicht/CImageLoaderWAL.h
source/Irrlicht/CIrrMeshFileLoader.h
source/Irrlicht/CSceneLoaderIrr.h
source/Irrlicht/CImageLoaderBMP.h
source/Irrlicht/CSkinnedMesh.h
source/Irrlicht/COpenGLParallaxMapRenderer.h
source/Irrlicht/CLWOMeshFileLoader.h
source/Irrlicht/CParticleRingEmitter.h
source/Irrlicht/COpenGLShaderMaterialRenderer.h
source/Irrlicht/CImageWriterTGA.h
source/Irrlicht/CD3D8MaterialRenderer.h
source/Irrlicht/CImageLoaderPNG.h
source/Irrlicht/COctreeTriangleSelector.h
source/Irrlicht/COpenGLTexture.h
source/Irrlicht/Octree.h
source/Irrlicht/os.h
source/Irrlicht/CD3D9MaterialRenderer.h
source/Irrlicht/CDefaultGUIElementFactory.h
source/Irrlicht/CAnimatedMeshHalfLife.h
source/Irrlicht/CSceneNodeAnimatorFlyCircle.h
source/Irrlicht/CD3D9ShaderMaterialRenderer.h
source/Irrlicht/CBSPMeshFileLoader.h
source/Irrlicht/CTriangleBBSelector.h
source/Irrlicht/S2DVertex.h
source/Irrlicht/CDefaultSceneNodeAnimatorFactory.h
source/Irrlicht/CGUIMessageBox.h
source/Irrlicht/CBoneSceneNode.h
source/Irrlicht/CGUITable.h
source/Irrlicht/CGUIColorSelectDialog.h
source/Irrlicht/CCubeSceneNode.h
source/Irrlicht/resource.h
source/Irrlicht/COpenGLNormalMapRenderer.h
source/Irrlicht/CSceneNodeAnimatorCameraMaya.h
source/Irrlicht/SoftwareDriver2_helper.h
source/Irrlicht/CGUIWindow.h
source/Irrlicht/CMD2MeshFileLoader.h
source/Irrlicht/dmfsupport.h
source/Irrlicht/CSTLMeshFileLoader.h
source/Irrlicht/CGUICheckBox.h
source/Irrlicht/CMeshManipulator.h
source/Irrlicht/CSoftware2MaterialRenderer.h
source/Irrlicht/CD3D9HLSLMaterialRenderer.h
source/Irrlicht/CSoftwareDriver.h
source/Irrlicht/IImagePresenter.h
source/Irrlicht/CGUIMeshViewer.h
source/Irrlicht/CMeshSceneNode.h
source/Irrlicht/CGUIImage.h
source/Irrlicht/CD3D8Driver.h
source/Irrlicht/CCameraSceneNode.h
source/Irrlicht/IZBuffer.h
source/Irrlicht/CAnimatedMeshSceneNode.h
source/Irrlicht/CGUIStaticText.h
source/Irrlicht/wglext.h
