=== debian/changelog ===
supertuxkart (0.8.1-2) unstable; urgency=medium

  * Disable support for wiimote input devices on !linux (since
    libbluetooth-dev is only built on linux archs).
  * Restrict build-dep libbluetooth-dev to linux-any.

 -- Vincent Cheng <Vincentc1208@gmail.com>  Fri, 20 Dec 2013 14:58:35 -0800

supertuxkart (0.8.1-1) unstable; urgency=low

  * Team upload

  [ Alexander Reichle-Schmehl ]
  * Removed myself from uploaders.

  [ Gianfranco Costamagna ]
  * New upstream release, patch refresh
  * Bumped std-version to 3.9.5, no changes required
  * Added libbluetooth-dev
  * Added lib/irrlicht/lib/Linux/libIrrlicht.a
    to debian/clean target
  * Moved images from xpm to png, since upstream has changed them

  [ Vincent Cheng ]
  * Run wrap-and-sort -sa
  * Re-added xpm icon for debian/menu.
  * Fix lintian error embedded-library (libjpeg, libpng, zlib).

 -- Vincent Cheng <Vincentc1208@gmail.com>  Thu, 19 Dec 2013 23:18:54 -0800
